#ifndef _PWOBJECT_H
#define _PWOBJECT_H

/*
	ProWesS, PROGS Windowing System

	Standard (public) definitions.

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 7 January 1995
*/

#include "err_h"

/* -- definition of a ProWesS event -- */

typedef struct _PWSystem PWSystem;
typedef union {
	struct _PWRegion *region;		/*	  region */
	struct _PWKeyPress *keypress;	/* OR keypress */
	} PWEvent;

/* -- definition of the dummy object (base of the real object) -- */

#define OSTATUS_REDRAW		(short)0x0001	/* set when redraw needed */
#define OSTATUS_REMOVE		(short)0x0002	/* set when should be removed */
#define OSTATUS_INITIALISED (short)0x0004	/* set when initialised */

#define PWBaseObject \
	PWTypeDef *type;				/* type of object */					\
	PWEvent event;					/* event associated with object */		\
	void *auxiliary;				/* auxiliary parameter for client */	\
	short status					/* object status */

struct _PWDummyObject {
	PWBaseObject;					/* common start for all objects */
	};

#endif _PWOBJECT_H
