/*
	ProWesS, PROGS Windowing System

	Definition of the tags for the standard types (and some data structures
	used by some of these types action routines).

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 7 January 1995
*/

#ifndef _WIN_H
#include "win_h"
#endif


#define PW_TAGMASK_STANDARD 	0x00001000	/* mask for standard tags */

#define PW_LOOSE_STATUS 		(0x001 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_TEXT			(0x002 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_STATUS_AVAILABLE 	0
#define PW_STATUS_UNAVAILABLE	-1
#define PW_STATUS_SELECTED		1
#define PW_LOOSE_CHANGE_STATUS	(0x003 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_WINDOW_DO		(0x004 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_CENTER_ITEM	(0x005 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_KEYPRESS		(0x006 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_ACTION_HIT 	(0x007 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_ACTION_DO		(0x008 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_ACTION_DRAW	(0x009 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_SIZE			(0x00a +PW_TAGMASK_MULTIPLE(2)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_XSIZE			(0x00b +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_YSIZE			(0x00c +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_AUTOSIZE		(0x00d +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_TEXT_COPY		(0x00f +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_LOOSE_AUTOREPEAT 	(0x010 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)

#define PW_OUTLINE_SLEEP		(0x020 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_SLEEP_TEXT	(0x021 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_QUIT 		(0x022 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_ACTION_QUIT	(0x023 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_QUIT_CONFIRM (0x024 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_QUIT_KEYPRESS (0x025+PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_ACTION_WAKE	(0x026 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_INFO_TEXT	(0x027 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_ACTION_INFO	(0x028 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_ACTION_DO	(0x029 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_HELP 		(0x02a +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_HELP_FILE	(0x02b +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_ACTION_HELP	(0x02c +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_TITLE_TEXT	(0x02d +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_BOX_LEFT 	(0x02e +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_BOX_RIGHT	(0x02f +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_HELP_POSITION (0x030+PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_HELP_DIRECTORY (0x31+PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_OBJECT_QUIT	(0x032 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_OBJECT_INFO	(0x033 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_OBJECT_DO	(0x034 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_OBJECT_WAKE	(0x035 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_OUTLINE_OBJECT_HELP	(0x036 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)

#define PW_CANVAS_SIZE			(0x040 +PW_TAGMASK_MULTIPLE(2)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_XSIZE 		(0x041 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_YSIZE 		(0x042 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_SIZE_PIX		(0x043 +PW_TAGMASK_MULTIPLE(2)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_XSIZE_PIX 	(0x044 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_YSIZE_PIX 	(0x045 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_ORIGIN		(0x046 +PW_TAGMASK_MULTIPLE(2)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_XORIGIN		(0x047 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_YORIGIN		(0x048 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_XSCROLL		(0x049 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_YSCROLL		(0x04a +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_TIMEOUT		(0x04b +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_ACTION_HIT	(0x04c +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_ACTION_DO 	(0x04d +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_ACTION_TIMEOUT	(0x04e +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_ACTION_HITDRAG	(0x04f +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_ACTION_DODRAG 	(0x050 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_ACTION_DRAGEND	(0x051 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_ACTION_REDRAW (0x052 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_ACTION_MOVE	(0x053 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_ACTION_EXIT	(0x054 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_POINTER		(0x055 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_REDRAW		(0x056 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_ACTION_SCALE		(0x057 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_CANVAS_ACTION_DRAGADJUST (0x059 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)

#define PW_SCROLL_CALCSIZE		(0x060 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_SCROLL_MINIMUM		(0x061 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_SCROLL_MAXIMUM		(0x062 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_SCROLL_NOBAR 		(0x063 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_SCROLL_MINDIST		(0x064 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_SCROLL_MAXDIST		(0x065 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_SCROLL_CANVAS		(0x066 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_SCROLL_SCROLL		(0x067 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_SCROLL_MIN_KEYPRESSES (0x068+PW_TAGMASK_MULTIPLE(2)+PW_TAGMASK_STANDARD)
#define PW_SCROLL_MAX_KEYPRESSES (0x069+PW_TAGMASK_MULTIPLE(2)+PW_TAGMASK_STANDARD)

#define PW_APPLIC_SCROLL_X		(0x070 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_APPLIC_SCROLL_Y		(0x071 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_APPLIC_SCROLLBAR_X	(0x072 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_APPLIC_SCROLLBAR_Y	(0x073 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_APPLIC_XSCROLL_LIST	(0x074 +PW_TAGMASK_TAGLIST+PW_TAGMASK_STANDARD)
#define PW_APPLIC_YSCROLL_LIST	(0x075 +PW_TAGMASK_TAGLIST+PW_TAGMASK_STANDARD)
#define PW_APPLIC_CANVAS_LIST	(0x076 +PW_TAGMASK_TAGLIST+PW_TAGMASK_STANDARD)

#define PW_TITLE_TEXT			(0x080 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)

#define PW_KEYPRESS_ACTION		(0x090 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)

#define PW_LABEL_TEXT			(0x0a0 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)

#define PW_EDLINE_MAXLENGTH 	(0x0b0 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_SET			(0x0b1 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_GET			(0x0b2 +PW_TAGMASK_MULTIPLE(2)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_WIDTH 		(0x0b3 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_WIDTH_PIX 	(0x0b4 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_WIDTH_FS		(0x0b5 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_KEYPRESS		(0x0b6 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_ACTION_AFTER	(0x0b7 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_EDLINE_AFTER	(0x0b8 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_EDLINE_NEXT	(0x0b9 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_EDLINE_PREV	(0x0ba +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_EDLINE_UP 	(0x0bb +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_EDLINE_DOWN	(0x0bc +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_ACTION_DO 	(0x0bd +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_ACTIVATE		(0x0be +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_ACTION_TEST	(0x0bf +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_EDLINE_TEST_CHANGE	1
#define PW_EDLINE_TEST_ACCEPT	0
#define PW_EDLINE_TEST_NOACCEPT -1
#define PW_EDLINE_ACTION_TEST_NATURAL	-1
#define PW_EDLINE_ACTION_TEST_INTEGER	-2
#define PW_EDLINE_ACTION_TEST_FLOAT 	-3

#define PW_MENU_ADD 			(0x0d0 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_MENU_ADD_COPY		(0x0d1 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_MENU_ADD_ARRAY		(0x0d2 +PW_TAGMASK_MULTIPLE(3)+PW_TAGMASK_STANDARD)
#define PW_MENU_ITEMWIDTH		(0x0d3 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_MENU_ITEMWIDTH_PIX	(0x0d4 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_MENU_ITEMWIDTH_FS	(0x0d5 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_MENU_ITEMWIDTH_MAX	(0x0d6 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_ACTION_SELECT	(0x0d7 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_MENU_ACTION_DESELECT (0x0d8 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_MENU_UNIQUE			(0x0d9 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_SORT_COMPARE	(0x0da +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_MENU_VISIBLE_LINES	(0x0db +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_MENU_CLEAR			(0x0dc +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_WINDOW_DO		(0x0dd +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_MENU_NONE_SELECTED	(0x0de +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_STATUS			(0x0df +PW_TAGMASK_MULTIPLE(2)+PW_TAGMASK_STANDARD)
#define PW_MENU_STATUS_CURRENT	(0x0e0 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_MENU_FIRST			(0x0e1 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_NEXT			(0x0e2 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_AVAILABLE_FIRST (0x0e3 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_AVAILABLE_NEXT	(0x0e4 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_SELECTED_FIRST	(0x0e5 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_SELECTED_NEXT	(0x0e6 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_FIRST_NUMBER	(0x0e7 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_NEXT_NUMBER 	(0x0e8 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_AVAILABLE_FIRST_NUMBER	(0x0e9 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_AVAILABLE_NEXT_NUMBER	(0x0ea +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_SELECTED_FIRST_NUMBER	(0x0eb +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_SELECTED_NEXT_NUMBER	(0x0ec +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_MENU_STATUS_ALL		(0x0ed +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_MENU_KEYPRESSES		(0x0ee +PW_TAGMASK_MULTIPLE(4)+PW_TAGMASK_STANDARD)

#define PW_INFOSTRING_TEXT		(0x0f0 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_INFOSTRING_AUTOSIZE	(0x0f1 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)

#define PW_INFOTEXT_TEXT		(0x100 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_INFOTEXT_WIDTH		(0x101 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_INFOTEXT_WIDTH_PIX	(0x102 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_INFOTEXT_WIDTH_FS	(0x103 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_INFOTEXT_LINES		(0x104 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)

#define PW_DIRSELECT_SET		(0x110 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_DIRSELECT_TITLE_TEXT (0x111 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_DIRSELECT_ACTIVATE	(0x112 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_DIRSELECT_ACTION 	(0x113 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_DIRSELECT_GET		(0x114 +PW_TAGMASK_MULTIPLE(2)+PW_TAGMASK_STANDARD)

#define PW_FILESELECT_TITLE_TEXT (0x120+PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_FILESELECT_ACTIVATE	(0x121 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_FILESELECT_ACTION	(0x122 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_FILESELECT_MULTIPLE	(0x123 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_FILESELECT_FILENAME	(0x124 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_FILESELECT_DIRECTORY (0x125 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_FILESELECT_EXTENSION (0x126 +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_FILESELECT_NOT_STATUS (0x127+PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)
#define PW_FILESELECT_BOX		(0x128 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_FILESELECT_OUTLINE	(0x129 +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_FILESELECT_MENU		(0x12a +PW_TAGMASK_MULTIPLE(0)+PW_TAGMASK_STANDARD)
#define PW_FILESELECT_SHOWSUB	(0x12b +PW_TAGMASK_MULTIPLE(1)+PW_TAGMASK_STANDARD)

/* definition of builtin types */

#define PW_TYPE_LOOSE_ITEM	0x4c4f4f53
#define PW_TYPE_TITLE_ITEM	0x5449544c
#define PW_TYPE_SEPARATOR	0x53455041
#define PW_TYPE_CONTAINER	0x434f4e54
#define PW_TYPE_DIRECTION	0x4b454550
#define PW_TYPE_GLUE		PW_TYPE_DIRECTION
#define PW_TYPE_KEYPRESS	0x4b455920
#define PW_TYPE_OUTLINE 	0x4f55544c
#define PW_TYPE_LABEL		0x4c41424c
#define PW_TYPE_CANVAS		0x43414e56
#define PW_TYPE_SCROLL		0x5343524f
#define PW_TYPE_APPLIC		0x4150504c
#define PW_TYPE_iTEM		0x6954454d
#define PW_TYPE_EDLINE		0x45444c49
#define PW_TYPE_MENU		0x4d454e55
#define PW_TYPE_INFOSTRING	0x494e4653
#define PW_TYPE_INFOTEXT	0x494e4654
#define PW_TYPE_DIRSELECT	0x4453454c
#define PW_TYPE_FILESELECT	0x4653454c
#define PW_TYPE_DIRECT_EDLINE	0x4445444c

/* structure passed for redrawing a canvas object */
typedef struct {
	pt xorg, yorg;					/* coordinate at topleft in canvas */
									/* could be any type of size sizeof(int) */
									/* PROforma coordinates */
	pt xsiz, ysiz;					/* size of area */
	pt xpos, ypos;					/* pointer position in area */
	Gstate gstate;					/* Gstate to draw in */
									/* window coordinates */
	short xpixsiz, ypixsiz; 		/* size of area */
	short xpixorg, ypixorg; 		/* origin of area in window */
	short xpixpos, ypixpos; 		/* pointer position in area */
	Window window;					/* window to draw in */
									/* conversion factors */
	pt Xpix2pt, Ypix2pt;			/* pixel to point conversion */
	pt Xpt2pix, Ypt2pix;			/* point to pixel conversion */
	short zero; 					/* always zero */
} CanvasInfo;

/* structure passed for testing the keystroke in an edline/dedline object */
typedef struct {
	int maxlength;					/* buffer length of string */
	char *string;					/* buffer with string */
	int length; 					/* length of string */
	int cursor; 					/* cursor pos, before string[cursor] */
	char key;						/* key which was pressed */
} EdlineInfo;
