/*
	ProWesS, PROGS Windowing System

	digital clock, uses software generated events

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 4 February 1996
*/

#include "job_h"
#include "str_h"
#include "time_h"

#include "ProWesS_h"

#define MAXLEN 50

Error subjob(Job job)
{
	while (TRUE)
	{
		JOBEventSend(job,EVENT_LEVEL1);
		JOBSuspend(MYSELF,50,NULL);
	}
}

typedef struct {
	char *string;
	PWObject object;
} Global;

Error redraw(PWObject object)
{
	Global *g;
	Time time;
	char temp[22];

	PWQuery(object,PW_GLOBAL_AUXILIARY,&g);
	TIMEGet(&time);
	TIMEString(time,temp);
	STRCopy(temp+12,g->string);
	PWChange(g->object,PW_INFOSTRING_TEXT,g->string,NULL);
	return ERR_OK;
}

Error init()
{
	Job me;
	char time[]="  :  :  ";
	Global g;

	g.string=time;

	JOBMe(&me);
	JOBCall(subjob,"clock events",1,1024,NULL,1,me);

	PWCreate(NULL,&g.object,PW_TYPE_INFOSTRING,
				PW_INFOSTRING_TEXT, time,
				PW_GLOBAL_AUXILIARY, &g,
				PW_SYSTEM_ACTION_EVENT1, redraw,
				PW_WINDOW_BUTTON,
				PW_INFOSTRING_AUTOSIZE, FALSE,
				NULL);
	return PWActivate(g.object);
}
