/*
	ProWesS, PROGS Windowing System

	ProWesS test for applic type -- demo with PROforma contents

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 15 May 1995
*/

#include "sms_h"
#include "win_h"
#include "ProWesS_h"

#define FONT "English 157"
#define STRING FONT
#define SIZE short2pt(100)
#define XMAX short2pt(500)
#define YMAX SIZE*7/5

pt Xpix2pt, Ypix2pt;
#define p100 short2pt(100)

Error redraw(PWObject object, CanvasInfo *rinfo)
{
	int i,j,siz;
	Gstate gid=rinfo->gstate;

	Xpix2pt=rinfo->Xpix2pt;
	Ypix2pt=rinfo->Ypix2pt;

	/* adjust bbox to fit canvas */
	PFPaperColourGray(gid,0);
	PFPageClear(gid);				/* clear background */
	PFColourGray(gid,pt_hundred);

	/* adjust page origin to reflect position in applic */
	PFPageOriginSet(gid,rinfo->xorg,rinfo->yorg);

	/* draw the contents (just some text) */
	PFFontLoad(gid,FONT);
	PFFontScale(gid,SIZE);
	PFMoveTo(gid,short2pt(10),SIZE);
	PFStringShow(gid,STRING);
}

void init()
{
	PWObject outl;

	LinkPROforma();

	PWCreate(NULL, &outl, PW_TYPE_OUTLINE,
				PW_OUTLINE_SLEEP_TEXT, "PROforma applic test",
				PW_OUTLINE_QUIT,
				NULL);

	PWCreate(outl, NULL, PW_TYPE_APPLIC,
				PW_APPLIC_CANVAS_LIST,
					PW_CANVAS_SIZE_PIX, 100,40,
					PW_CANVAS_ACTION_REDRAW, &redraw,
					PW_CANVAS_POINTER, SPRITE_HAND,
					NULL,
				PW_APPLIC_SCROLLBAR_Y,
				PW_APPLIC_YSCROLL_LIST,
					PW_SCROLL_MINDIST, short2pt(20),
					PW_SCROLL_MAXDIST, -short2pt(20),
					PW_SCROLL_MAXIMUM, YMAX,
					NULL,
				PW_APPLIC_SCROLLBAR_X,
				PW_APPLIC_XSCROLL_LIST,
					PW_SCROLL_MINDIST, short2pt(20),
					PW_SCROLL_MAXDIST, -short2pt(20),
					PW_SCROLL_MAXIMUM, XMAX,
					NULL,
				NULL);

	PWActivate(outl);
}
